//+------------------------------------------------------------------+
//|                                             CurrencyAnalyser.mq4 |
//|                                                      DarzanMihai |
//|                                             www.digitalenergy.ro |
//+------------------------------------------------------------------+
#property copyright "DarzanMihai"
#property link      "www.digitalenergy.ro"

extern string explic = "analyze_type = 0(Moving Average)|1(Closing Price)";
extern int analyze_type = 0;
extern int prd=10;


string currency;
string sym_c1;
string sym_c2;
double valute1_strength;
double valute2_strength;
string comment_init;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   currency = Symbol();
   sym_c1 = StringSubstr(currency,0,3);
   sym_c2 = StringSubstr(currency,3,3);
   valute1_strength=0;
   valute2_strength=0;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   Analiza(analyze_type);
   Display();
      
//----
   return(0);
  }
//+------------------------------------------------------------------+

int Sugestie (string currency, int n=10, int tip=0){//must return -1, 1 or 0
//Moving Average --------------**************-------------  
   if (tip==0){//moving average
      double MA0, MA0_2;
      double MAn, MAn_2;
      double M0, M2, med0,med2;
      double ind_ma=0;
   
      MA0 = iMA(currency,0,14,0,MODE_EMA,PRICE_CLOSE,0);
      MA0_2 = iMA(currency,0,52,0,MODE_EMA,PRICE_CLOSE,0);
   
      MAn = iMA(currency,0,14,0,MODE_EMA,PRICE_CLOSE,n);       
      MAn_2 = iMA(currency,0,52,0,MODE_EMA,PRICE_CLOSE,n);            
   
      M0 = MAn-MA0;
      M2 = MAn_2-MA0_2;
   
      med0 = (MAn+MA0)/2;
      med2 = (MAn_2+MA0_2)/2;

      //determinam ind_ma
      if (M0>0)//in scadere pe 14
      {
         if (M2>0)//in scadere pe 52
         {
            ind_ma = -1;
         }else{//in crestere pe 52
            if (med0>med2) {ind_ma = -1;}
         }
      }else{//in crestere pe 14
         if (M2>0)//in scadere pe 52
         {
            if (med0<med2) {ind_ma = 1;}
         }else{//in crestere pe 52
            ind_ma = 1;
         }
      }
      return (ind_ma);
   }
//Closing Price --------------**************-------------     
   if (tip==1){//closing price
      double med_close=0, sum_close=0, current_bid=0;
      for (int i = n; i >= 0; i--) {
         sum_close += iClose(currency,0,n);
      }
      med_close = sum_close/n;
      current_bid = MarketInfo(currency,MODE_BID);
      if (med_close>current_bid){return(-1);}else{return(1);}
      if (med_close==current_bid){return(0);}
   }
}

void Analiza(int tip=0){
   valute1_strength=Valute_strength(sym_c1,tip);
   valute2_strength=Valute_strength(sym_c2,tip);
}

double Valute_strength(string sym_c1,int tip=0){
   int count_s1=0, NR_S1=0;
   
   if(sym_c1=="USD"){
      count_s1=Sugestie("USDPLN",prd,tip)+Sugestie("USDCHF",prd,tip)+Sugestie("USDJPY",prd,tip)+Sugestie("USDCAD",prd,tip)+Sugestie("USDCZK",prd,tip)-Sugestie("EURUSD",prd,tip)-Sugestie("GBPUSD",prd,tip)-Sugestie("AUDUSD",prd,tip)-Sugestie("NZDUSD",prd,tip);
      NR_S1 = 9;
   }
   if(sym_c1=="EUR"){
      count_s1=Sugestie("EURPLN",prd,tip)+Sugestie("EURUSD",prd,tip)+Sugestie("EURCHF",prd,tip)+Sugestie("EURJPY",prd,tip)+Sugestie("EURAUD",prd,tip)+Sugestie("EURCAD",prd,tip)+Sugestie("EURCZK",prd,tip)+Sugestie("EURNZD",prd,tip);
      NR_S1 = 8;
   }
   if(sym_c1=="GBP"){
      count_s1=Sugestie("GBPPLN",prd,tip)+Sugestie("GBPUSD",prd,tip)+Sugestie("GBPJPY",prd,tip)+Sugestie("GBPCHF",prd,tip)+Sugestie("GBPAUD",prd,tip)+Sugestie("GBPNZD",prd,tip)-Sugestie("EURGBP",prd,tip);
      NR_S1 = 7;
   }
   if(sym_c1=="CHF"){
      count_s1=Sugestie("CHFPLN",prd,tip)+Sugestie("CHFJPY",prd,tip)-Sugestie("USDCHF",prd,tip)-Sugestie("EURCHF",prd,tip)-Sugestie("GBPCHF",prd,tip)-Sugestie("CADCHF",prd,tip);
      NR_S1 = 6;
   }
   if(sym_c1=="CAD"){
      count_s1=Sugestie("CADJPY",prd,tip)+Sugestie("CADCHF",prd,tip)-Sugestie("USDCAD",prd,tip)-Sugestie("EURCAD",prd,tip)-Sugestie("AUDCAD",prd,tip);
      NR_S1 = 5;
   }
   if(sym_c1=="AUD"){
      count_s1=Sugestie("AUDUSD",prd,tip)+Sugestie("AUDJPY",prd,tip)+Sugestie("AUDNZD",prd,tip)+Sugestie("AUDCHF",prd,tip)+Sugestie("AUDCAD",prd,tip)-Sugestie("EURAUD",prd,tip)-Sugestie("GBPAUD",prd,tip);
      NR_S1 = 7;
   }
   if(sym_c1=="JPY"){
      count_s1=-Sugestie("USDJPY",prd,tip)-Sugestie("EURJPY",prd,tip)-Sugestie("GBPJPY",prd,tip)-Sugestie("CHFJPY",prd,tip)-Sugestie("AUDJPY",prd,tip);
      NR_S1 = 5;
   }
   double strength;
   strength = count_s1*100/NR_S1;
   return (strength);
}

void Display(){
   double symbol_strength = 0;
   symbol_strength=valute1_strength-valute2_strength;
   
   if (valute1_strength!=0 && valute2_strength!=0){
      Comment(comment_init+"\n",
               "Puterea "+sym_c1+": "+valute1_strength+" %"+"\n",
               "Puterea "+sym_c2+": "+valute2_strength+" %"+"\n",
               "Puterea "+Symbol()+": "+symbol_strength+" %");
   }else{
      string valute1_comm = "";
      string valute2_comm = "";
      string symbol_comm = "Unreliable!";
      if (valute1_strength==0){valute1_comm="Unreliable!";}else{valute1_comm=DoubleToStr(valute1_strength,2);}
      if (valute2_strength==0){valute2_comm="Unreliable!";}else{valute2_comm=DoubleToStr(valute1_strength,2);}
      Comment(comment_init+"\n",
               "Strength "+sym_c1+": "+valute1_comm+" %"+"\n",
               "Strength "+sym_c2+": "+valute2_comm+" %"+"\n",
               "Strength "+Symbol()+": "+symbol_comm);
   }
}


